#include <iostream>
#include <cstdarg>

#include "elemlist.hh"

using std::cout;
using std::endl;

template<unsigned level, typename T>
void BuildDemo(T marked, const T *map, const T *goal, const T *axis, ...)
{
    elemlist<level, T> elems;
    
    unsigned len[level], pos[level];
    const char *axi[level];
    va_list ap;
    va_start(ap, axis);
    for(unsigned a=0; a<level; ++a)
    {
        if(a)axis = va_arg(ap, const T *);
        axi[a] = axis;
        len[a] = strlen(axis);
        pos[a] = 0;
    }
    va_end(ap);
    
    const T *mp = map;
    for(;;)
    {
        if(*mp++ == marked)
        {
            elemlist<level, T>::Elem tmp;
            for(unsigned a=0; a<level; ++a)
                tmp.insert(a, axi[a][pos[a]]);
            elems.insert(tmp);
        }
        
        unsigned b=0;
    Re:
        if(++pos[b] != len[b])continue;
        pos[b] = 0;
        if(++b == level)break;
        goto Re;
    }
    
#ifdef ELEMLIST_DEBUG
    cout << "= "; 
    elems.dump();
    cout << endl;
#endif
    
    /* At this point, we have a list of A*B*C -type elements. Singular. */
    
    elems.optimize();
    
#ifdef ELEMLIST_DEBUG
    cout << endl; elems.dump();
            cout << "        = result\n";
#endif
    cout << goal << "        = goal\n";
    
    cout << endl << endl;
}

static void BuildDemo()
{
    BuildDemo<2> ('X',
         "..X.X"
         "XXX.X"
         "XXXXX"
         "XXXXX",
         "CE*FGHI + ABCE*GHI + ABCDE*HI",
         "ABCDE", "FGHI");
    
    BuildDemo<2> ('X',
         "....."
         "..X.X"
         ".XXX."
         ".XXXX",
         "CE*GI + BCD*HI",
         "ABCDE", "FGHI");
    
    BuildDemo<2> ('X',
         "X..X."
         "X.X.X"
         "X.XXX"
         "X.XXX",
         "AD*FHI + ACE*GHI",
         "ABCDE", "FGHI");

    BuildDemo<1> ('X',
         "XX.X..X",
         "ABDG",
         "ABCDEFG");

    BuildDemo<3> ('X',
         ".X"
         "XX"
         ".."
         "XX"
         ".."
         "XX",
         
         "B*CD*G + AB*D*GHI",
         
         "AB", "CD", "GHI");

    BuildDemo<2> ('X',
         "XX."
         "X.X"
         ".XX",
         "AB*D + AC*E + BC*F",
         "ABC", "DEF");
}

int main(void)
{
    BuildDemo();
    
    return 0;
}
